VERSION 5.00
Begin VB.Form PaletteF 
   Caption         =   "Color Palette"
   ClientHeight    =   2145
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7140
   LinkTopic       =   "Form1"
   ScaleHeight     =   143
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   476
   StartUpPosition =   3  'Windows-Standard
   Begin VB.OptionButton Option1 
      Caption         =   "P2 Image"
      Height          =   210
      Index           =   3
      Left            =   5985
      TabIndex        =   7
      Top             =   105
      Width           =   1095
   End
   Begin VB.OptionButton Option1 
      Caption         =   "P2 Picture"
      Height          =   210
      Index           =   2
      Left            =   4845
      TabIndex        =   6
      Top             =   105
      Width           =   1095
   End
   Begin VB.OptionButton Option1 
      Caption         =   "P1 Image"
      Height          =   210
      Index           =   1
      Left            =   3675
      TabIndex        =   5
      Top             =   105
      Width           =   1005
   End
   Begin VB.OptionButton Option1 
      Caption         =   "P1 Picture"
      Height          =   210
      Index           =   0
      Left            =   2535
      TabIndex        =   4
      Top             =   105
      Value           =   -1  'True
      Width           =   1095
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1935
      TabIndex        =   2
      Text            =   "32"
      Top             =   75
      Width           =   405
   End
   Begin VB.CommandButton cmdPalette 
      Caption         =   "Refresh"
      Height          =   300
      Left            =   90
      TabIndex        =   1
      Top             =   45
      Width           =   1245
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   1740
      Left            =   75
      ScaleHeight     =   112
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   463
      TabIndex        =   0
      Top             =   390
      Width           =   7005
   End
   Begin VB.Label Label1 
      Caption         =   "Width"
      Height          =   225
      Left            =   1425
      TabIndex        =   3
      Top             =   90
      Width           =   525
   End
End
Attribute VB_Name = "PaletteF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim cPalette() As Long
Public Function DisplayPalette()
    
    Dim wi As Long
    Dim hei As Long
    Dim xmax As Long
    Dim ymax As Long
    
    xmax = Val(Text1.Text)
    wi = Int((Me.ScaleWidth - 2 * Picture1.Left) / xmax)
    If (256 / xmax) - (256 \ xmax) > 0 Then
        ymax = (256 \ xmax) + 1
    Else
        ymax = (256 \ xmax)
    End If
    hei = (Me.ScaleHeight - Picture1.Top - Picture1.Left) / ymax
    If hei < wi Then
        wi = hei
    Else
        hei = wi
    End If
     
    bo = Picture1.Width - Picture1.ScaleWidth
    Picture1.Width = bo + wi * xmax
    Picture1.Height = bo + hei * ymax
    j = 0
    i = -1
    'Picture1.ForeColor = SwapRedBlue(cPalette(i))
    Picture1.Cls
    Picture1.FillStyle = 0
    For Y = 0 To UBound(cPalette)
        For X = 0 To xmax - 1
            i = i + 1
            Picture1.FillColor = (cPalette(i))
            Picture1.Line (X * wi, Y * hei)-(X * wi + wi, Y * hei + hei), 0, B
            If i = UBound(cPalette) Then
                GoTo exi
            End If
        Next X
    Next Y
exi:
    
End Function


Public Sub cmdPalette_Click()
    
    Dim res As Long
    Dim handle As Long
    
    res = Form1.GetRes()
    res = Val(Form1.optRe(res).Tag)
    
    For i = 0 To 3
        If Option1(i).Value = True Then
            Exit For
        End If
    Next i
    Select Case i
    Case 0
        handle = Form1.Picture1.Picture
    Case 1
        handle = Form1.Picture1.Image
    Case 2
        handle = Form1.Picture2.Picture
    Case 3
        handle = Form1.Picture1.Image
    End Select
    
    ' Hier wird die Palette ermittelt, die bei einer
    ' Konversion verwendet werden wrde. Falls ein Bitmaphandle
    ' bergeben wird, welches eine Palettenbitmap enthlt, wird
    ' diese angezeigt. Ansonsten wird die Systempalette verwendet.
    ret = GetPalette_AllRes(Form1.Picture1.hdc, handle, res, cPalette())
    Picture1.Cls
    If ret >= 0 Then
        Call DisplayPalette
    Else
        'MsgBox "Es konnte keine Palette gelesen werden!"
    End If
    
   
exi:
    'SavePicture Picture1.Image, App.Path + "\Palette256.bmp"

End Sub




Private Sub Form_Load()
    'Call cmdPalette_Click
End Sub


Private Sub Option1_Click(Index As Integer)
    Call cmdPalette_Click
End Sub

